//*************************************************************************
//* --------------------
//* S4CALClusterMaker
//* --------------------
//* (Description)
//*	This set of classes makes CALClusters.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/02  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>
#include "JSFSteer.h"
#include "S4CALHitMaker.h"
#include "S4CALHitMakerBuf.h"
#include "S4CALClusterMaker.h"
#include "S4CALClusterMakerBuf.h"

ClassImp(S4CALClusterMaker)

//=====================================================================
//* constructor -------------------------------------------------------
S4CALClusterMaker::S4CALClusterMaker(const Char_t *name,
                                     const Char_t *title)
                 : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------
S4CALClusterMaker::~S4CALClusterMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------
Bool_t S4CALClusterMaker::Initialize()
{
  std::cerr << " S4CALClusterMaker::Initialize called" << std::endl;
  fEventBuf = new S4CALClusterMakerBuf(this);
  return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------

Bool_t S4CALClusterMaker::BeginRun(Int_t /* run */)
{
  return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4CALClusterMaker::Process(Int_t /* ev */)
{
  S4CALHitMaker        *hmp  = static_cast<S4CALHitMaker *>(gJSF->FindModule("S4CALHitMaker"));
  S4CALHitMakerBuf     *hmbp = static_cast<S4CALHitMakerBuf *>(hmp->EventBuf());
  S4CALClusterMakerBuf *cmbp = static_cast<S4CALClusterMakerBuf *>(EventBuf());
  cmbp->MakeClusters(hmbp->GetOutputBufPtr());

  return kTRUE;
}
