#ifndef S4CALCLUSTERMAKERBUF_H
#define S4CALCLUSTERMAKERBUF_H
//*************************************************************************
//* ---------------------
//* S4CALClusterMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes CALClusters. 
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4CALClusterMakerBuf		: buffering class
//* (Update Record)
//*	2004/09/04  S.Yamamoto	Original version.
//*************************************************************************

#include "TObjArray.h"
#include "S4CALClusterMaker.h"

class S4CALClusterMakerBuf : public JSFEventBuf {
friend class S4CALClusterMaker;
public:
  S4CALClusterMakerBuf(S4CALClusterMaker *mod     = 0,
                       const Char_t      *name    = "S4CALClusterMakerBuf",
                       const Char_t      *title   = "CAL Cluster Buffer", 
                       Int_t              bufsize = 50);
  virtual ~S4CALClusterMakerBuf();
    
  virtual TObjArray   *GetOutputBufPtr();  // returns pointer to cluster buffer 

  virtual void 	       DebugPrint(const Char_t *opt = "");  

private:  
  virtual void	MakeClusters(TObjArray *clusters); // Make Clustercs

private:
  TObjArray    *fOutputBufPtr;          // Output buffer ptr
  Int_t         fBufSize;               // output buffer size

  ClassDef(S4CALClusterMakerBuf, 1) // Cluster data buffer
};
#endif
