#include "S4CALHitFilter.h"
#include "S4CALHit.h"

ClassImp(S4CALHitFilter)

//=====================================================================
//* constructor -------------------------------------------------------

S4CALHitFilter::S4CALHitFilter(Double_t emin, Double_t tmax)
           : fEmin(emin), // energy threshold [GeV]  
             fTmax(tmax)  // timing cut       [ns]
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4CALHitFilter::~S4CALHitFilter()
{
}

//=====================================================================
//* IsOK -----------------------------------------------------------

Bool_t S4CALHitFilter::IsOK(const S4CALHit &chit)
{
  return const_cast<S4CALHit &>(chit).GetEnergyDeposit() > fEmin 
         && const_cast<S4CALHit &>(chit).GetTime() < fTmax;
}
