#ifndef S4CALHITFILTER_H
#define S4CALHITFILTER_H

//*************************************************************************
//* ---------------------
//* S4CALHitFilter Class
//* ---------------------
//* (Description)
//*	This class defines CALHit filter.
//* (Requires)
//*     TObject	
//* (Provides)
//*	S4CALHitFilter		: filter class
//* (Update Record)
//*	2004/11/15  S.Yamamoto	Original version.
//*************************************************************************

#include "TObject.h"

class S4CALHit;

class S4CALHitFilter : public TObject {
public:
  S4CALHitFilter(Double_t emin = 0.0, Double_t tmax = 1.e20);
  virtual ~S4CALHitFilter();

  virtual Bool_t IsOK(const S4CALHit &chit); // validate hit

private:
  Double_t fEmin;            // energy threshold [GeV]  
  Double_t fTmax;            // timing cut       [ns]  

  ClassDef(S4CALHitFilter, 1)   //  CAL hit filter class
};
#endif
