//*****************************************************************************
//* ==============
//* S4CALHitMaker
//* ==============
//*   METIS module to make (smeared) CAL hits.
//*   Mother class: S4VHit
//*
//* (Update Record)
//*   2004.07.31  A.Sanchez  Primitive version.
//*****************************************************************************
#include "S4CALHitMaker.h"
#include "S4CALHitMakerBuf.h"
#include "S4CALMCTruthBuf.h"
#include "S4CALExactHit.h"
#include "S4CALHit.h"
#include "S4CALPreHit.h"
#include "JSFSteer.h"

#include "TRandom.h"

#include <map>
#include <utility>
#include <iostream>
#include <vector>

ClassImp(S4CALHitMaker);

S4CALHitMaker::S4CALHitMaker(const Char_t *name,
			     const Char_t *title,
			     const Char_t *opt)
             : JSFModule(name, title, opt) 
{
}

//============================================================================
S4CALHitMaker::~S4CALHitMaker()
{
  if (fEventBuf) delete fEventBuf;
}

//============================================================================
Bool_t S4CALHitMaker::Initialize()
{
  if (fEventBuf) delete fEventBuf;
  fEventBuf = new S4CALHitMakerBuf(this,"S4CALHitMakerBuf","S4CALHits Data");
  return kTRUE;
}

//============================================================================
Bool_t S4CALHitMaker::Process(Int_t ev)
{
  S4CALHitMakerBuf *hmbp = static_cast<S4CALHitMakerBuf *>(EventBuf());
  S4CALMCTruth    *mctp  = static_cast<S4CALMCTruth *>(gJSF->FindModule("S4CALMCTruth","quiet"));
  S4CALMCTruthBuf *mctbp = static_cast<S4CALMCTruthBuf *>(mctp->EventBuf());

  return hmbp->MakeHits(mctbp->GetExactHitsPtr());
}
