#ifndef S4CALHITMAKERBUF_H
#define S4CALHITMAKERBUF_H
//$Id: S4CALHitMaker.h,v 1.7 2005/10/27 03:08:23 fujikawa Exp $
//*****************************************************************************
//* ================
//* S4CALHitMakerBuf
//* ================
//*   METIS module to make (smeared) CAL hits.
//*   Mother class: S4VHit
//*
//* (Update Record)
//*   2004.07.31  A.Sanchez  Primitive version.
//*****************************************************************************

#include "JSFModule.h"
#include "TObjArray.h"
#include "S4CALHit.h"

class S4CALHitMaker;

class S4CALHitMakerBuf : public JSFEventBuf {
public:
  S4CALHitMakerBuf(S4CALHitMaker* hitmaker = 0,
	      const Char_t * name     = "S4CALHitMakerBuf",
	      const Char_t * title    = "S4CALHitMaker Buf",
                    Int_t    bufsize  = 10000);
  virtual ~S4CALHitMakerBuf();

  TObjArray *GetOutputBufPtr()          { return fOutputBufPtr; }
  S4CALHit  *GetHitPtr      (Int_t i=0) { return static_cast<S4CALHit*>(fOutputBufPtr->At(i)); }

  static Int_t    GetHitMakingScheme()        { return fgScheme; }
  static void     SetHitMakingScheme(Int_t s) { fgScheme = s;    }

  Bool_t MakeHits    (TObjArray *hits);
  void   MergeHits   (TObjArray *hits);

private:
  TObjArray      *fOutputBufPtr;     // output buffer ptr
  Int_t           fBufSize;          // output buffer size
  static Int_t    fgScheme;          // (0,1) = (realistic, idealistic)

  ClassDef(S4CALHitMakerBuf, 1) // CAL (smeared) hit buffer
};
#endif
