//*************************************************************************
//* --------------------
//* S4CPFOMaker
//* --------------------
//* (Description)
//*	This set of classes makes CPFOs.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/09/02  S.Yamamoto	Original version.
//*************************************************************************

#include <iostream>
#include "JSFSteer.h"
#include "S4CPFOMaker.h"
#include "S4CPFOMakerBuf.h"
#include "S4HYBTrackMaker.h"
#include "S4HYBTrackMakerBuf.h"
#include "S4CALClusterMakerBuf.h"

ClassImp(S4CPFOMaker)

//=====================================================================
//* constructor -------------------------------------------------------
S4CPFOMaker::S4CPFOMaker(const Char_t *name, const Char_t *title)
           : JSFModule(name,title)
{
}

//=====================================================================
//* destructor --------------------------------------------------------
S4CPFOMaker::~S4CPFOMaker()
{
}

//=====================================================================
//* Initialize --------------------------------------------------------
Bool_t S4CPFOMaker::Initialize()
{
   std::cerr << " S4CPFOMaker::Initialize called " << std::endl;
   fEventBuf = new S4CPFOMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* BeginRun ----------------------------------------------------------
Bool_t S4CPFOMaker::BeginRun(Int_t /* run */)
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------
Bool_t S4CPFOMaker::Process(Int_t /* ev */)
{
   S4CALClusterMaker    *cmp  = static_cast<S4CALClusterMaker *>(gJSF->FindModule("S4CALClusterMaker"));
   S4CALClusterMakerBuf *cmbp = static_cast<S4CALClusterMakerBuf *>(cmp->EventBuf());
   S4CPFOMakerBuf       *pmbp = static_cast<S4CPFOMakerBuf *>(EventBuf());

   pmbp->MakePFOs(cmbp->GetOutputBufPtr());

   return kTRUE;
}

