#ifndef S4CPFOMAKERBUF_H
#define S4CPFOMAKERBUF_H
//*************************************************************************
//* ---------------------
//* S4CPFOMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes CPFOs. 
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4CPFOMakerBuf		: buffering class
//* (Update Record)
//*	2004/09/04  S.Yamamoto	Original version.
//*************************************************************************

#include "S4CPFOMaker.h"
#include "TObjArray.h"

class S4CPFOMakerBuf : public JSFEventBuf {
friend class S4CPFOMaker;
public:
  S4CPFOMakerBuf(S4CPFOMaker *mod     = 0,
                 const Char_t      *name    = "S4CPFOMakerBuf",
                 const Char_t      *title   = "PFO Buffer");
  virtual ~S4CPFOMakerBuf();
    
  virtual TObjArray   *GetOutputBufPtr();  // returns pointer to cluster buffer 

  virtual void 	       DebugPrint(const Char_t *opt = "");  

private:  
  virtual void	MakePFOs(TObjArray *clusters); // Make PFOs

private:
  TObjArray    *fOutputBufPtr;          // Output buffer ptr

  ClassDef(S4CPFOMakerBuf, 1) // PFO data buffer
};
#endif
