#ifndef S4PFOBJECT_H
#define S4PFOBJECT_H

#include "TLorentzVector.h"
#include "TAttLockable.h"
#include "TAttDrawable.h"

class S4CALCluster;
class S4HYBTrack;

class S4PFObject : public TLorentzVector, 
                   public TAttLockable, 
                   public TAttDrawable {
public:
  S4PFObject(S4CALCluster *cp = 0, S4HYBTrack *tp = 0);
  virtual ~S4PFObject();

  inline  S4CALCluster *GetClusterPtr() { return fClusterPtr; }
  inline  S4HYBTrack   *GetTrackPtr  () { return fTrackPtr;   }

  using TAttDrawable::Draw;
  virtual void Draw(Int_t color, const Char_t *opt = "");

  void  DebugPrint(const Option_t *opt = "");

private:
  S4CALCluster *fClusterPtr; // pointer to cluster
  S4HYBTrack   *fTrackPtr;   // pointer to track

  ClassDef(S4PFObject, 1) // PFO class
};
#endif
