#include "S4HYBTrack.h"
#include "S4CALPreHit.h"
#include "S4BreakPoint.h"

#include <iostream>

ClassImp(S4HYBTrack)

S4HYBTrack::S4HYBTrack(S4BreakPoint *bpp)
          : fTrackID(bpp ? bpp->GetTrackID() : -9999999),
            fPreHitPtr(dynamic_cast<S4CALPreHit *>(bpp->GetPHitPtr())),
	    fBreakPointPtr(bpp),
	    fEnergy(bpp ? bpp->GetFourMomentum().E() : 0.),
	    fMomentum(bpp ? bpp->GetFourMomentum().Vect() : TVector3(0.))
{
}

S4HYBTrack::~S4HYBTrack()
{
}

void S4HYBTrack::Draw(Int_t color, const Char_t *opt)
{
}

void S4HYBTrack::DebugPrint(const Option_t *opt)
{
  using namespace std;
  Int_t phtid = fPreHitPtr ? fPreHitPtr->GetHitID() : -999999;
  cerr << " -- S4HYBTrack::DebugPrint ---------------------- " << endl
       << "  phtid = "  << phtid                               << endl
       << "  phPtr = "  << fPreHitPtr                          << endl
       << "  bpPtr = "  << fBreakPointPtr                      << endl
       << "  E     = "  << GetEnergy()                         << endl
       << "  P     = (" << GetMomentum().X() << ","                 
                        << GetMomentum().Y() << ","       
                        << GetMomentum().Z() << ")"            << endl 
       << " ------------------------------------------------ " << endl;
}
