#ifndef S4HYBTRACK_H
#define S4HYBTRACK_H

#include "TObjArray.h"
#include "TVector3.h"
#include "TAttLockable.h"
#include "TAttDrawable.h"

class S4CALPreHit;
class S4BreakPoint;

class S4HYBTrack : public TObjArray, public TAttLockable, public TAttDrawable {
public:
  S4HYBTrack(S4BreakPoint *bpp = 0);
  virtual ~S4HYBTrack();

  inline Int_t         GetTrackID      () { return fTrackID;       }
  inline Double_t      GetEnergy       () { return fEnergy;        }
  inline TVector3     &GetMomentum     () { return fMomentum;      }
  inline S4CALPreHit  *GetPreHitPtr    () { return fPreHitPtr;     }
  inline S4BreakPoint *GetBreakPointPtr() { return fBreakPointPtr; }

  using  TAttDrawable::Draw;  
  void   Draw(Int_t color, const Char_t *opt = "");

  void   DebugPrint(const Option_t *opt = "");

private:
  Int_t         fTrackID;       // J4 track ID
  S4CALPreHit  *fPreHitPtr;     // pointer to prehit if any
  S4BreakPoint *fBreakPointPtr; // pointer to break point if any
  Double_t      fEnergy;        // energy   [GeV]
  TVector3      fMomentum;      // momentum [GeV]

  ClassDef(S4HYBTrack, 1) // hybrid track class
};
#endif
