#ifndef __CINT__
#include "TNtupleD.h"
#include <fstream>
#include <cmath>
using namespace std;
#endif

void mass(const char *infile="pythia_event.data")
{
   TNtupleD *tup1 = new TNtupleD("tup1","tup1","ecm:mz");
   ifstream in(infile);
   int    np;
   int    ist, id, jda1, jda2;
   double px, py, pz, m;
   int    iev = 0;
   while (in >> np) {
      double ecm = 0;
      double mz  = 0;
      iev++;
      for (int i=0; i<np; i++) {
         in >> ist >> id >> jda1 >> jda2 >> px >> py >> pz >> m;
         if (!jda1) ecm += sqrt(px*px + py*py + pz*pz + m*m);
         if (id == 23) mz = m;
      }
      tup1->Fill(ecm, mz);
   }
   tup1->Draw("ecm");
}
