// $Id: J4MaterialCatalog.hh,v 1.5 2008/02/20 02:47:04 miyamoto Exp $
#ifndef J4MATERIALCATALOG_H
#define J4MATERIALCATALOG_H
// ====================================================================
//    J4MaterialCatalog.hh
//
/// ====================================================================
#include "G4Element.hh"
#include "G4Material.hh"
#include "G4MaterialTable.hh"
#include "G4MaterialPropertiesTable.hh"

// ====================================================================
//
// class definition
//
// ====================================================================
 
class J4MaterialCatalog {

protected:
  J4MaterialCatalog();   // constructor should NOT be public. 
  
public:
  ~J4MaterialCatalog();
  
  inline static  J4MaterialCatalog*  OpenCatalog();
  G4Material*    Order(const G4String& name,
                       G4MaterialPropertiesTable* mtable=0) const;
  static void Print();

private:  
  void  ReadMaterialCatalog();
    
private:
  static J4MaterialCatalog* 	fMaterialCatalog;
  const  G4MaterialTable*       fMaterialTable;
  const  G4ElementTable*        fElementTable;
};

// ====================================================================
// inline definition
// ====================================================================

J4MaterialCatalog* J4MaterialCatalog::OpenCatalog()
{
  if (!fMaterialCatalog) {
     fMaterialCatalog= new J4MaterialCatalog();
  } 
  
  return fMaterialCatalog;
}
#endif
