#ifndef J4DETECTORCONSTRUCTION_H
#define J4DETECTORCONSTRUCTION_H
// $Id: J4DetectorConstruction.hh,v 1.1 2004/06/08 09:03:21 miyamoto Exp $

//*************************************************************************
//* --------------------------
//* J4DetectorConstruction.hh
//* --------------------------
//* (Description)
//* 	Class for describing his/her detector setup.
//*     Mother class : G4VUserDetectorConstruction (abstruct class)
//*    
//* (Update Record)
//*	2001/01/18  K.Hoshina	Original version.
//*************************************************************************

#include "G4VUserDetectorConstruction.hh"
#include "G4ThreeVector.hh"
#include "J4EXPHall.hh"
#include "J4TypeDef.hh"
#include "J4VComponent.hh"

//=====================================================================
//---------------------
// class definition
//---------------------

class J4DetectorConstruction : public G4VUserDetectorConstruction {
public:
  J4DetectorConstruction();
  ~J4DetectorConstruction();

  G4VPhysicalVolume   *Construct(); 
    
  static  J4EXPHall   *GetEXPHall()             { return fgEXPHall; }

  J4ObjArray  	       GetComponents()    const { return fComponents; }

  const G4ThreeVector &GetSizeOfEXPHall() const 
                       { return fgEXPHall->GetSizeOfEXPHall(); }
  
  void	AddComponent(J4VComponent *dtc) 
        { 
           fComponents.push_back(dtc); 
        }     

private:
  static J4EXPHall    *fgEXPHall;
  J4ObjArray           fComponents;
};

#endif
