// $Id: J4DetectorConstruction.cc,v 1.1 2004/06/08 09:03:23 miyamoto Exp $
//*************************************************************************
//* --------------------------
//* J4DetectorConstruction.cc
//* --------------------------
//* (Description)
//* 	
//*     
//* (Update Record)
//*	2000/12/08  K.Hoshina	Original version.
//*************************************************************************


#include "J4DetectorConstruction.hh"
#include "J4EXPHall.hh"

J4EXPHall* J4DetectorConstruction::fgEXPHall = 0; 

//************************************************************************
//---------------------
// Class Description
//---------------------
 
//=====================================================================
//* constructor -------------------------------------------------------

J4DetectorConstruction::J4DetectorConstruction()
{  
   fgEXPHall  = new J4EXPHall(0, 1, 1, 0);
}

//=====================================================================
//* destructor --------------------------------------------------------

J4DetectorConstruction::~J4DetectorConstruction()
{
}

//=====================================================================
//* Construct   -------------------------------------------------------

G4VPhysicalVolume* J4DetectorConstruction::Construct()
{
    std::cerr << std::endl
           << "##------------------------------------------------##" << std::endl
           << "## ============================================== ##" << std::endl
           << "##   J4DetectorConstruction::Construct()          ##" << std::endl
           << "## ============================================== ##" << std::endl
           << "##                                                ##" << std::endl
           << "##    Start installing all of the components      ##" << std::endl
           << "##          into Experimental Hall...             ##" << std::endl
           << "##                                                ##" << std::endl
           << "##------------------------------------------------##" << std::endl
           << std::endl;
  
    G4int ncomponents = fComponents.size();
    
#if 1
    std::cerr << "ncomponents=" << ncomponents << std::endl;
#endif
    for (G4int i=0; i<ncomponents; i++) {
    	J4VComponent* detector 
    		= (J4VComponent *)fComponents.operator[](i);     
    	detector->InstallIn(fgEXPHall);
    	fgEXPHall->SetDaughter(detector);
    }  

    std::cerr << std::endl
           << "##------------------------------------------------##" << std::endl
           << "## ============================================== ##" << std::endl
           << "##   J4DetectorConstruction::Construct()          ##" << std::endl
           << "## ============================================== ##" << std::endl
           << "##                                                ##" << std::endl
           << "##    Finished installation of the components!    ##" << std::endl
           << "##                                                ##" << std::endl
           << "##------------------------------------------------##" << std::endl
           << std::endl;

  // ==============================================================
  // return PV of the world volume
    return fgEXPHall->GetPV();
}

